/* yasep/tool/YASMed.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org

created 2009-01-23 by yg@yasep.org as tools/listed.js
2009-01-26
2009-01-31
2009-02-01
2009-02-06 : moved most code to the listed object
2009-02-10 : style changes, feedback from St<E9>phane Moriaux etc.
Feb 12 01:07:16 2009 : style changes again
Feb 16 02:34:50 2009
todo : gestion des <E9>v<E9>nements avec seamonkey : souris qui d<E9>tecte pas le rel<E2>chement du bouton
Feb 24 01:30:28 2009 : j'ai 32 ans ! et j'ai r<E9>uni les 2 images de la poubelle en une [:kikiv]
2009-07-07 : moved to tools/
2009-07-11 : new argument to ygwm.new_window
2009-07-22 : column hiding
2009-07-27 : duplicate_listing_row fixed
lun. févr. 13 04:59:42 CET 2012 : YASMed.js


Purpose : Create and maintain windows of the
 iterative assembly editor (derived from listed)

TODO : cleanup the trigger

 */

init_obj.push(YASMed={
  serial:0,  // must be set by a cookie !!!

  OddEvenArray:["even", "odd"],

/*
Trash should be moved out, as an generic service

<div id="trash_div" style="display:none">
<img src="tool/trash.png" id="trash_image">
</div>

//    YASMed.trash_id=getById("trash_image");

  TrashOpen: function() {

  },

  TrashClose: function() {

  },

 trash_mouseover:function() {
  if ((listed.dragdropstate > 0) // drag&drop ?
   ||(ygwm.action_function==ygwm.mouse_drag)) { // interaction with ygwm
    listed.trash_image_id.style.left="0px";
    listed.trash_open=true;
  }
  return true;
},

// serves also as a callback for ygwm
trash_mouseout:function() {
  if (listed.trash_open) {
    listed.trash_image_id.style.right="0px";
    listed.trash_open=false;
    // detect that a window is being closed
    // cleanup of the moved window... getElement(,,) ?
    // cleanup the variables to avoid leaks
    return true;
  }
  return false;
},*/

  export_ASM:function(ev, win) {
    if (!win)
      win=this;
    win=ygwm.getParent(win);
    if (win) {
      // ok now we have the window.
      var h="; "+win.FuncName+"\n; Generated on "+new Date().toGMTString()+"\n",
          t= win.list_header_id.nextSibling;
      while(t) {
        h+=t.source_id.source+"\n";
        t=t.nextSibling;
      }
      savefile.save(win.FuncName+".yas",h);
    }
  },

  export_HEX:function(ev, win) {
    if (!win)
      win=this;
    win=ygwm.getParent(win);
    if (win) {
      // ok now we have the window.
      var h=";;yhx0\n;; Dump of "+win.FuncName+"\n;; Generated on "+new Date().toGMTString()+"\n",
          t= win.list_header_id.nextSibling, i;
      while(t) {
        if(t.bytes)
          for(i in t.bytes_array)
            h+=int2hex( t.bytes_array[i],1,1,1)+" ";
        if(t.source_id.source!="")
          h+="; "+t.source_id.source+"\n";
        t=t.nextSibling;
      }
      savefile.save(win.FuncName+".yhx",h);
    }
  },

  //////////////////////////////////////////////////////
  // cleanup a table, remove any #text node inbetween the TR TH and TDs
  // (proved to be necessary......)
  cleanup_table:function(tbody_id) {
    var t=tbody_id.firstChild, tr, td, td2;   /// !!!!
    // scan the tbody
    while (t) {
      // preload the next sibling because we might remove t
      tr=t.nextSibling;
      if (t.nodeName!="TR")
        tbody_id.removeChild(t);
      else {
        // recurse : scan the TD/TH
        td = t.firstChild;
        while (td != null) {
          td2=td.nextSibling;
          if ((td.nodeName!="TD")&&(td.nodeName!="TH"))
            t.removeChild(td);
          td=td2;
        }
      }
      t=tr;
    }
  },

  Reassemble: function(t){
    var u=t.parentNode;
    var win=ygwm.getParent(u);
    YASMed.AssembleLine(win,u,t.source);
    YASMed.renumber_lines(win,u,u.TrLineNr,u.address);
  },

  renumber_lines:function(win,t,n,ad) {
    // first parameter : id of the first TR to modify
    // 2nd parm: its intended line number;
    // 3rd parm: byte address
    var parent=t.parentNode;

    while (t != null) {
      t.className=YASMed.OddEvenArray[n & 1]; // update the background color
      t.numero_id.innerHTML=n;  // create/update the numbers
      t.TrLineNr = n++;

      t.address=ad;

      if (t.bytes>0){
        t.address_id.innerHTML=ad;
        ad+=t.bytes;
      }
      t=t.nextSibling; // go to the next element
    }

    // if the end of the list is reached,
    if (t == null) {
      parent.nbElements=n; // update the element count.
      win.LastAddress_id.innerHTML=(win.LastAddress=ad);
    }
  },

  MakeRow: function(c) {
    var i,j,k, t=document.createElement("TR");
    for (i in c){
      j=document.createElement("TD");
      k=c[i];
      t[k+'_id']=j;
      j.className=k;
      switch(k) {
        case "plus" :   j.onclick=YASMed.duplicate_listing_row; break; // adapter plus tard
        case "source":
          edit_text.register(j,
            { size:60, maxsize:200, func:YASMed.Reassemble });
      }
      t.appendChild(j);
    }
    return t;
  },

//  NewSym: function(win,s) {
//    return YASMed.MakeRow(["numero","symval","symname","symtype", "symcomm","symdef","symused"]);
//  },

  AssembleLine: function(win,t,s) {
    win.asm_error="";
    win.asmout="";
    t.source_id.source=s;
    t.source_id.innerHTML=s.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;");
    Y.encode_instruction(s,win.asmctx);
    if (t.bytes=win.asmctx.encoded_size_bytes) {
      t.size_id.innerHTML=t.bytes;
      t.bytes_array=win.bytes_array;
    }
    else
      t.size_id.innerHTML="";
    t.value_id.innerHTML=win.asmout;
    t.message_id.innerHTML=win.asm_error;
  },

  listed_id:["plus","numero","address","size","value","source","message"],

  NewLine: function(win,s) {
    var t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.appendChild(t);
    YASMed.AssembleLine(win,t,s);
    YASMed.renumber_lines(win,t,win.listed_id.nbElements,win.LastAddress);
  },

  FirstLine: function(ev) {
    var win=ygwm.getParent(this),
        t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.insertBefore(t,win.list_header_id.nextSibling);
    YASMed.AssembleLine(win,t,"");
    YASMed.renumber_lines(win,t,0,win.start_address);
    return false;
  },

  duplicate_listing_row:function(ev) {
    // this is the id of the <td class="plus">
    var originalTR = this.parentNode,  // the TR
        p=originalTR.parentNode,       // The table
        win=ygwm.getParent(p);         // the window

    if (!ev.ctrlKey) { // Duplicate
      // new row:
      var newTR = YASMed.MakeRow(YASMed.listed_id);
      // include the new row in the table (which forces reflow and redraw)
      p.insertBefore(newTR,originalTR.nextSibling);
//      YASMed.AssembleLine(win,newTR,originalTR.source_id.source);
      YASMed.renumber_lines(win,newTR, originalTR.TrLineNr+1, originalTR.address+originalTR.bytes);
    }
    else {  // Erase
      if(originalTR.nextSibling)
        YASMed.renumber_lines(win,originalTR.nextSibling, originalTR.TrLineNr, originalTR.address);
      p.removeChild(originalTR);
    }
  },

  // Create a new editor
  start: function() {
    var plus, win, f="function"+YASMed.serial++,
      cont=document.createElement("DIV");
    cont.innerHTML=import_htmi("tool/YASMed");
    winman.patchInnerLinks(cont);
    win = ygwm.new_window("YASMed "+f, null, cont,
       600, 450, 120, 60, false, true, true, true, false, "doc_cygr");
    YASMed.cleanup_table(win.listed_id=getByClass("table_listing","TBODY",cont));
    win.list_header_id=getById("list_header","tr",cont);
    win.listed_id.nbElements=0;
    getById("export_asm","input",win).onclick=YASMed.export_ASM;
    getById("export_hex","input",win).onclick=YASMed.export_HEX;
    (plus=getByClass("plus","th",win.list_header_id)).onclick=YASMed.FirstLine;

    // update the listing name :
    (win.name_id=getByClass("block_name","SPAN",win)).innerHTML=(win.FuncName=f);
    edit_text.register(win.name_id, { size:40,
       func: function(t){ win.FuncName=t.source },
       check: edit_text.filter_alpha });

    (win.start_address_id=getByClass("start_address","SPAN",win)).innerHTML=  win.start_address=
     (win.LastAddress_id =getByClass("last_address", "SPAN",win)).innerHTML=  win.LastAddress=   0;

    win.asmctx=new Y.ASM_context(
        function(col,msg){  // message display routine
          win.asm_error ='<span style="background-color:'+col+'">&nbsp;</span> '+msg;
        },
        function(data, size){ // emit_bin
          var i=[],h="";
          while (size--) { // displays every byte
            i.push(data&255);
            h=int2hex(data&255,1,1,1)+h;
            data>>=8;
          }
          win.bytes_array=i;
          win.asmout=h;
        },
        true
      );

    return win;
  },

  init_obj: function(){
    YASMed.menuItem = menu.subMenuItem(menu.mainMenuItem("Tools"),"New&nbsp;ASM&nbsp;editor", "tool/YASMed");
  }
});
